package v2;

import javax.swing.table.*;
import java.util.*;

/**
 *
 * @author F.Dubisy
 *
 */


/* Tout objet de cette classe est un modle de donnes,
 *  savoir un ensemble de lignes et de colonnes sous forme d'un tableau  deux dimensions.
 * Un modle de donnes contient galement le nom des colonnes.
 * Un modle de donnes peut tre affich dans une JTable.
 */
public class MyTableModel extends AbstractTableModel
    {// Liste des noms de colonnes
     ArrayList <String> nomCol = new ArrayList <String>();
     // Donnes sous forme d'une liste de listes (liste  deux dimensions)
     ArrayList <Object> contenu = new ArrayList<Object>();
     // Liste d'objets types (pour retrouver le type des colonnes)
     ArrayList <Object> objetTypes = new ArrayList <Object>();

     MyTableModel(ArrayList <String> col, ArrayList <Object> lig, ArrayList <Object> types)
     {nomCol = col;
      contenu = lig;
      objetTypes = types;
     }

     // Retourne le nombre de colonnes
     public int getColumnCount()
     {return nomCol.size();
     }

     // Retourne le nombre de lignes
     public int getRowCount()
     {return contenu.size();
     }

     // Retourne le nom de la colonne numro "col"
     public String getColumnName(int col)
     {return  nomCol.get(col);
     }

     // Retourne la valeur de la cellule  l'intersection de la ligne numro "row" et de la colonne numro "col"
     public Object getValueAt(int row, int col)
     { ArrayList vect = (ArrayList)(contenu.get(row));
       return vect.get(col);
     }

     /* Retourne la classe correspondant aux valeurs de la colonne numro "c".
      * Cette mthode est appele entre autres lors de l'affichage des colonnes dans la JTable 
      * afin d'afficher le bon type des colonnes (numriques aligns  droite, 
      * chanes de caractres alignes  gauche, boolens sous forme de cases  cocher, date avec format de date, ...)
      */
     public Class getColumnClass (int c)
     {return (objetTypes.get(c)).getClass();
     }

    }

